#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct CreateSpatialRequest {
    #[builder(into)]
    #[serde(rename = "title")]
    title: String,
    #[serde(rename = "daggerUuid")]
    dagger_uuid: conjure_object::Uuid,
    #[builder(custom(type = super::SpatialTypeMetadata, convert = Box::new))]
    #[serde(rename = "typeMetadata")]
    type_metadata: Box<super::SpatialTypeMetadata>,
    #[builder(default, set(item(type = String, into)))]
    #[serde(
        rename = "labels",
        skip_serializing_if = "std::collections::BTreeSet::is_empty",
        default
    )]
    labels: std::collections::BTreeSet<String>,
    #[builder(default, map(key(type = String, into), value(type = String, into)))]
    #[serde(
        rename = "properties",
        skip_serializing_if = "std::collections::BTreeMap::is_empty",
        default
    )]
    properties: std::collections::BTreeMap<String, String>,
    #[builder(default, set(item(type = super::super::super::rids::api::MarkingRid)))]
    #[serde(
        rename = "markingRids",
        skip_serializing_if = "std::collections::BTreeSet::is_empty",
        default
    )]
    marking_rids: std::collections::BTreeSet<super::super::super::rids::api::MarkingRid>,
    #[builder(default, into)]
    #[serde(rename = "description", skip_serializing_if = "Option::is_none", default)]
    description: Option<String>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "startTimestamp", skip_serializing_if = "Option::is_none", default)]
    start_timestamp: Option<Box<super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "endTimestamp", skip_serializing_if = "Option::is_none", default)]
    end_timestamp: Option<Box<super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Handle>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "sourceHandle", skip_serializing_if = "Option::is_none", default)]
    source_handle: Option<Box<super::super::super::super::api::Handle>>,
    #[builder(default, into)]
    #[serde(rename = "workspace", skip_serializing_if = "Option::is_none", default)]
    workspace: Option<conjure_object::ResourceIdentifier>,
}
impl CreateSpatialRequest {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        title: impl Into<String>,
        dagger_uuid: conjure_object::Uuid,
        type_metadata: super::SpatialTypeMetadata,
    ) -> Self {
        Self::builder()
            .title(title)
            .dagger_uuid(dagger_uuid)
            .type_metadata(type_metadata)
            .build()
    }
    #[inline]
    pub fn title(&self) -> &str {
        &*self.title
    }
    /// UUID of the Dagger model that backs this spatial asset. Callers must create the
    /// model in Dagger before calling create.
    #[inline]
    pub fn dagger_uuid(&self) -> conjure_object::Uuid {
        self.dagger_uuid
    }
    #[inline]
    pub fn type_metadata(&self) -> &super::SpatialTypeMetadata {
        &*self.type_metadata
    }
    #[inline]
    pub fn labels(&self) -> &std::collections::BTreeSet<String> {
        &self.labels
    }
    #[inline]
    pub fn properties(&self) -> &std::collections::BTreeMap<String, String> {
        &self.properties
    }
    /// The markings to apply to the created spatial asset.
    /// If not provided, the asset will be visible to all users in the same workspace.
    #[inline]
    pub fn marking_rids(
        &self,
    ) -> &std::collections::BTreeSet<super::super::super::rids::api::MarkingRid> {
        &self.marking_rids
    }
    #[inline]
    pub fn description(&self) -> Option<&str> {
        self.description.as_ref().map(|o| &**o)
    }
    /// Start of the time range covered by this spatial asset.
    #[inline]
    pub fn start_timestamp(
        &self,
    ) -> Option<&super::super::super::super::api::Timestamp> {
        self.start_timestamp.as_ref().map(|o| &**o)
    }
    /// End of the time range covered by this spatial asset.
    #[inline]
    pub fn end_timestamp(&self) -> Option<&super::super::super::super::api::Timestamp> {
        self.end_timestamp.as_ref().map(|o| &**o)
    }
    /// Optional reference to the original source data (e.g., S3 path) for provenance tracking.
    #[inline]
    pub fn source_handle(&self) -> Option<&super::super::super::super::api::Handle> {
        self.source_handle.as_ref().map(|o| &**o)
    }
    /// The workspace in which to create the spatial asset. If not provided, the asset will be created in
    /// the default workspace for the user's organization, if the default workspace is configured.
    #[inline]
    pub fn workspace(&self) -> Option<&conjure_object::ResourceIdentifier> {
        self.workspace.as_ref().map(|o| &*o)
    }
}
